AutoCAD顧問
還沒有註冊嗎...即日起免費註冊,所有最完整的AutoCAD討論、教學及資源都在論壇裡喔~

[已解決]AUTOLISP 炸開&拉伸的指令

上一篇主題 下一篇主題 向下

[已解決]AUTOLISP 炸開&拉伸的指令

發表 由 r1543761189 于 周一 3 10月 2011 - 2:20

如題 請問各位前輩 炸開及拉伸的指令中副選項該怎麼用??

小弟 使用的是AUTOCAD 2004版
以下 是我測試時用的程式 "圖框" 是500*500 正方型

(defun c:01 ()

(setq aa (List 0 0))

(setq bb (List 1000 1000))

(command "insert" "圖框" (LIST 50 50) 1 1 0 )

(command "_EXPLODE" "c" aa bb ))


以上會出現
*無效的選取*
應有一個點或 上一個(L)/全部(ALL)/群組(G)
; 錯誤: 函數被取消



如果要把炸開的方形(500*500) 拉伸成500*1000 要怎麼寫
(command "stretch" ....)


r1543761189 在 周二 4 10月 2011 - 1:51 作了第 1 次修改
avatar
r1543761189
一般會員
一般會員

文章總數 : 21
年齡 : 36
來自 : 彰化
職業 : 設計
愛好 : 布袋戲
個性 : 安靜
使用年資 : 新手初學
使用版本 : 新手初學
經驗值 : 2244
威望值 : 0
注冊日期 : 2011-09-30
男 天秤座 猴

回頂端 向下

回復: [已解決]AUTOLISP 炸開&拉伸的指令

發表 由 adslwang 于 周一 3 10月 2011 - 13:59

我也是新手這些簡單的東西 可以參考看看
第一個問題 這樣就可以執行炸開指令了 如沒有加入第一行炸開是執行不了的 當初剛在練習的時後也發生過這個問題 直到去國外網站發現 要用這樣的方式來寫 但是它的原因如何我就不清楚 不知到其它的前輩知道的是否可以指點一二。
(setvar "qaflags" 1)
(SETQ EN (SSGET))
(command "EXPLODE" EN "")

第二個問題,可以考慮一下別的思路 不一定要執行很多其它指令 只要能將程式簡化 又能達到效果 這樣最好 這是書上寫的 另外加入Y及N來辨視執行結果
(defun c:01()
(setq aa (List 0 0))
(setq bb (List 1000 1000))
(command "-insert" "圖框" (LIST 50 50) 1 1 0 )
(setq gg1 (entlast))
(initget 1 "Y N")
(SETQ change_REC (getkword "\n 是否繼續下面結果 (Y)將矩型變更為500,1000 (N)直接離開:"))
(setq sr (strcase change_REC))
(COND
((= sr "Y")
(command "erase" gg1 "")
(command "rectang" (LIST 50 50) (LIST 550 1050) "")
(PRINC "\n **將矩型變更為500,1000**"))
((= sr "N")
(PRINC "\n **畫框練習**")))
(prin1)
)



adslwang 在 周一 3 10月 2011 - 16:13 作了第 1 次修改
avatar
adslwang
高級會員
高級會員

文章總數 : 372
年齡 : 38
來自 : 台南
職業 : 自由業
愛好 : 電腦、旅行
個性 : 樂觀
使用年資 : 1年
使用版本 : 2009
積分 : 17
經驗值 : 4545
威望值 : 355
回帖精華 : 1
注冊日期 : 2008-10-02
藍鵲88號
男 處女座 馬

回頂端 向下

回復: [已解決]AUTOLISP 炸開&拉伸的指令

發表 由 r1543761189 于 周一 3 10月 2011 - 15:02

謝謝您的指導!

(setvar "qaflags" 1)<---這行加上去就可以炸開了

再請問 一般如果是用滑鼠圈選會分"由左至右圈"或是"由右至左圈"
用LISP程式寫的是不是沒有區分?


第2個方式您是用重新劃一個矩形的方式

因為我想拉伸的圖塊它有倒角(倒角是固定的尺寸),
矩形是會變更的
所以我想用拉伸就可以不用去變更倒角的尺寸了。
(因為有很多種倒角,所以想做成圖塊再用拉伸的)
avatar
r1543761189
一般會員
一般會員

文章總數 : 21
年齡 : 36
來自 : 彰化
職業 : 設計
愛好 : 布袋戲
個性 : 安靜
使用年資 : 新手初學
使用版本 : 新手初學
經驗值 : 2244
威望值 : 0
注冊日期 : 2011-09-30
男 天秤座 猴

回頂端 向下

回復: [已解決]AUTOLISP 炸開&拉伸的指令

發表 由 adslwang 于 周一 3 10月 2011 - 16:10

r1543761189 寫到:謝謝您的指導!

(setvar "qaflags" 1)<---這行加上去就可以炸開了

再請問 一般如果是用滑鼠圈選會分"由左至右圈"或是"由右至左圈"
用LISP程式寫的是不是沒有區分?
第2個方式您是用重新劃一個矩形的方式
因為我想拉伸的圖塊它有倒角(倒角是固定的尺寸),
矩形是會變更的
所以我想用拉伸就可以不用去變更倒角的尺寸了。
(因為有很多種倒角,所以想做成圖塊再用拉伸的)

留點想像的空間 自己想一下吧!(因為這是很基礎的東西歐,沒有添加如其它前輩寫的複雜,我累了..)
滑鼠圈選會分"由左至右圈"或是"由右至左圈"-----跟一般的一樣,跟框選及窗選的方式一樣,再看一下f1了解其中的意思。
所以我想用拉伸就可以不用去變更倒角的尺寸了。-------其實可以很多導角也好 另外再附加長度也好 在lisp將長度跟導角當成變數也是可以達到的,如果使用圖塊就變成只能使用插入加上動態圖塊方式,將該圖塊炸開後也是一樣等於0,您可能還需要將書上前幾章練一下,再自己動一下腦吧!
avatar
adslwang
高級會員
高級會員

文章總數 : 372
年齡 : 38
來自 : 台南
職業 : 自由業
愛好 : 電腦、旅行
個性 : 樂觀
使用年資 : 1年
使用版本 : 2009
積分 : 17
經驗值 : 4545
威望值 : 355
回帖精華 : 1
注冊日期 : 2008-10-02
藍鵲88號
男 處女座 馬

回頂端 向下

回復: [已解決]AUTOLISP 炸開&拉伸的指令

發表 由 r1543761189 于 周二 4 10月 2011 - 1:45

adslwang 大大 謝謝您的指導

以下是我測試的程式可以用了!謝謝


(defun c:02 ()

(setq aa (List 50 50))

(setq bb (List 0 0))

(setq PT1 (List 0 100))

(setq PT2 (List 1000 600))

(setq PT3 (List 1000 600))

(setq PT4 (List 1000 700))

(command "insert" "圖框" (LIST 50 50) 1 1 0 )

(setvar "qaflags" 1)

(command "EXPLODE" "c" aa bb "" )

(COMMAND "STRETCH" "C" PT2 PT1 "" PT3 PT4)

(prin1))
avatar
r1543761189
一般會員
一般會員

文章總數 : 21
年齡 : 36
來自 : 彰化
職業 : 設計
愛好 : 布袋戲
個性 : 安靜
使用年資 : 新手初學
使用版本 : 新手初學
經驗值 : 2244
威望值 : 0
注冊日期 : 2011-09-30
男 天秤座 猴

回頂端 向下

回復: [已解決]AUTOLISP 炸開&拉伸的指令

發表 由 adslwang 于 周二 4 10月 2011 - 4:12

不用客氣 謝謝蘋果爸這個平台吧
有機會可以戶相討論
avatar
adslwang
高級會員
高級會員

文章總數 : 372
年齡 : 38
來自 : 台南
職業 : 自由業
愛好 : 電腦、旅行
個性 : 樂觀
使用年資 : 1年
使用版本 : 2009
積分 : 17
經驗值 : 4545
威望值 : 355
回帖精華 : 1
注冊日期 : 2008-10-02
藍鵲88號
男 處女座 馬

回頂端 向下

回復: [已解決]AUTOLISP 炸開&拉伸的指令

發表 由 Tiger&蘋果爸 于 周二 4 10月 2011 - 8:07

adslwang 寫到:不用客氣 謝謝蘋果爸這個平台吧
有機會可以戶相討論
很高興大家可以在這良性互動、教學相長!
認同

____________________________________________________________________________________
avatar
Tiger&蘋果爸
系統管理員
系統管理員

文章總數 : 17080
年齡 : 41
來自 : 台北市文山區
職業 : AutoCAD顧問
愛好 : 蹓狗/戶外活動/拍照
個性 : 幽默/樂觀/善良
使用年資 : 15↑
使用版本 : AutoCAD 2016
經驗值 : 63953
威望值 : 12657
注冊日期 : 2008-04-23
2D基礎函授 2D進階函授 3D基礎函授 https://i11.servimg.com/u/f11/19/71/67/71/2d3d10.png2D+3D線上 顧問外掛程式 經典問與答讀者 藍鵲1號
2009聚會勳章 2010聚會勳章 2011聚會勳章 2012聚會勳章 2013勳章-2D基礎 2014聚會勳章 2015聚會勳章 2016聚會勳章 串連貼紙成功 男 水瓶座 兔

http://mypaper.pchome.com.tw/kv1012tiger

回頂端 向下

上一篇主題 下一篇主題 回頂端


 
這個論壇的權限:
無法 在這個版面回復文章